/*
 * All of the documentation and software included in the
 * BLM Software is copyrighted by Jesse Davis and Pedro Domingos.
 * The arguments.cpp, arguments.h, hasharray.h, hash.h, hashint.h
 * flbfgsb.h, lbfgsb.h, random.h and timer.h come from the
 * Alchemy Software system. These files are denoted as coming from
 * Alchemy.
 * 
 * Copyright [2010] Jesse Davis and Pedro Domingos All rights reserved.
 * 
 * Contact: Jesse Davis, University of Washington
 * (jdavis@cs.washington.edu).
 * 
 * Redistribution and use in source and binary forms, with
 * or without modification, are permitted provided that
 * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above
 * copyright notice, this list of conditions and the
 * following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the
 * above copyright notice, this list of conditions and the
 * following disclaimer in the documentation and/or other
 * materials provided with the distribution.
 * 
 * 3. All advertising materials mentioning features or use
 * of this software must display the following
 * acknowledgment: "This product includes software
 * developed by Jesse Davis and Pedro in the 
 * Department of Computer Science and Engineering 
 * at the University of Washington".
 * 
 * 4. Your publications acknowledge the use or
 * contribution made by the Software to your research
 * using the following citation(s): 
 * Jesse Davis and Pedro Domingos, 
 * "Bottom-Up Learning of Markov Network Structure",
 * 27th International Conference on Machine Learning, 2010
 *
 * 
 * 5. Neither the name of the University of Washington nor
 * the names of its contributors may be used to endorse or
 * promote products derived from this software without
 * specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE UNIVERSITY OF WASHINGTON
 * AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE UNIVERSITY
 * OF WASHINGTON OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

#ifndef LEARNWTS_H_NOV_23_2005
#define LEARNWTS_H_NOV_23_2005

#include <sys/time.h>
#include "rule.h"

class LearnWts{
 public:
  static Array<int>* parseExample(string buffer){
    Array<int>* ex = new Array<int>;
    Array<string> token;
    tokenize(buffer, token,",");
    for(int ix  = 0; ix < token.size(); ix++){
      ex->append(atoi(token[ix].c_str()));
    }
    return ex;
  }
  static void tokenize(const string& str,
		Array<string>& tokens,
		const string& delimiters = " ")
  {
    // Skip delimiters at beginning.
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".1
    string::size_type pos     = str.find_first_of(delimiters, lastPos);
    
    while (string::npos != pos || string::npos != lastPos)
      {
	// Found a token, add it to the vector.
	tokens.append(str.substr(lastPos, pos - lastPos));
	// Skip delimiters.  Note the "not_of"
	lastPos = str.find_first_not_of(delimiters, pos);
      // Find next "non-delimiter"
	pos = str.find_first_of(delimiters, lastPos);
      }
  }
};

#endif
